#ifndef traffic_light_detect_h
#define traffic_light_detect_h

#include <stdbool.h>
#include <stdint.h>
#include <Arduino.h>
#include "MeConfig.h"
#include "MeSerial.h"

#ifdef ME_PORT_DEFINED
#include "MePort.h"
#endif

#define RED_COLOR      0
#define GREEN_COLOR    1
#define YELLOW_COLOR   2
#define LOWER          0
#define UPPER          1

///@brief Class for DemoClass
class TrafficLightDetect : public MeSerial
{
  public:
    TrafficLightDetect(uint8_t port);
    void loop();
    boolean set_color_range(uint8_t color,uint8_t type,uint8_t h,uint8_t s,uint8_t v);
    boolean set_hough_circles_parameter(uint8_t color,int16_t minDist,int16_t operator_threshold,int16_t accumulator_threshold,int16_t min_radius,int16_t max_radius);
    boolean set_hs_judgment_threshold(uint8_t color,int16_t threshold);
    uint8_t get_traffic_light_status(void);
    boolean read_serial_port();
    void parseCmd(char * cmd);
    void parseGcode(char *cmd);
  private:
    volatile uint8_t traffic_light_status = 0;
    char buf[32];
    volatile uint8_t bufindex = 0;
    volatile boolean data_flag = false;
    volatile boolean start_cmd = false;
};

#endif /* traffic_light_detect_h */
